//******************************************************************************
//  Copyright (c) 2005-2009 by Jan Van hijfte
//
//  See the included file COPYING.TXT for details about the copyright.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//******************************************************************************


C_EXPORT QPictureH QPicture_create(int formatVersion)
{
	return (QPictureH) new QPicture(formatVersion);
}

C_EXPORT void QPicture_destroy(QPictureH handle)
{
	delete (QPicture *)handle;
}

C_EXPORT QPictureH QPicture_create2(const QPictureH p1)
{
	return (QPictureH) new QPicture(*(const QPicture*)p1);
}

C_EXPORT bool QPicture_isNull(QPictureH handle)
{
	return (bool) ((QPicture *)handle)->isNull();
}

C_EXPORT int QPicture_devType(QPictureH handle)
{
	return (int) ((QPicture *)handle)->devType();
}

C_EXPORT uint QPicture_size(QPictureH handle)
{
	return (uint) ((QPicture *)handle)->size();
}

C_EXPORT const char* QPicture_data(QPictureH handle)
{
	return (const char*) ((QPicture *)handle)->data();
}

C_EXPORT void QPicture_setData(QPictureH handle, const char* data, uint size)
{
	((QPicture *)handle)->setData(data, size);
}

C_EXPORT bool QPicture_play(QPictureH handle, QPainterH p)
{
	return (bool) ((QPicture *)handle)->play((QPainter*)p);
}

C_EXPORT bool QPicture_load(QPictureH handle, QIODeviceH dev, const char* format)
{
	return (bool) ((QPicture *)handle)->load((QIODevice*)dev, format);
}

C_EXPORT bool QPicture_load2(QPictureH handle, PWideString fileName, const char* format)
{
	QString t_fileName;
	copyPWideStringToQString(fileName, t_fileName);
	return (bool) ((QPicture *)handle)->load(t_fileName, format);
}

C_EXPORT bool QPicture_save(QPictureH handle, QIODeviceH dev, const char* format)
{
	return (bool) ((QPicture *)handle)->save((QIODevice*)dev, format);
}

C_EXPORT bool QPicture_save2(QPictureH handle, PWideString fileName, const char* format)
{
	QString t_fileName;
	copyPWideStringToQString(fileName, t_fileName);
	return (bool) ((QPicture *)handle)->save(t_fileName, format);
}

C_EXPORT void QPicture_boundingRect(QPictureH handle, PRect retval)
{
	QRect t_retval;
	t_retval = ((QPicture *)handle)->boundingRect();
	copyQRectToPRect(t_retval, retval);
}

C_EXPORT void QPicture_setBoundingRect(QPictureH handle, PRect r)
{
	QRect t_r;
	copyPRectToQRect(r, t_r);
	((QPicture *)handle)->setBoundingRect(t_r);
}

C_EXPORT void QPicture_detach(QPictureH handle)
{
	((QPicture *)handle)->detach();
}

C_EXPORT bool QPicture_isDetached(QPictureH handle)
{
	return (bool) ((QPicture *)handle)->isDetached();
}

C_EXPORT const char* QPicture_pictureFormat(PWideString fileName)
{
	QString t_fileName;
	copyPWideStringToQString(fileName, t_fileName);
	return (const char*) QPicture::pictureFormat(t_fileName);
}

C_EXPORT void QPicture_inputFormatList(QStringListH retval)
{
	*(QStringList *)retval = QPicture::inputFormatList();
}

C_EXPORT void QPicture_outputFormatList(QStringListH retval)
{
	*(QStringList *)retval = QPicture::outputFormatList();
}

C_EXPORT QPaintEngineH QPicture_paintEngine(QPictureH handle)
{
	return (QPaintEngineH) ((QPicture *)handle)->paintEngine();
}

C_EXPORT QPictureIOH QPictureIO_create()
{
	return (QPictureIOH) new QPictureIO();
}

C_EXPORT void QPictureIO_destroy(QPictureIOH handle)
{
	delete (QPictureIO *)handle;
}

C_EXPORT QPictureIOH QPictureIO_create2(QIODeviceH ioDevice, const char* format)
{
	return (QPictureIOH) new QPictureIO((QIODevice*)ioDevice, format);
}

C_EXPORT QPictureIOH QPictureIO_create3(PWideString fileName, const char* format)
{
	QString t_fileName;
	copyPWideStringToQString(fileName, t_fileName);
	return (QPictureIOH) new QPictureIO(t_fileName, format);
}

C_EXPORT const QPictureH QPictureIO_picture(QPictureIOH handle)
{
	return (const QPictureH) &((QPictureIO *)handle)->picture();
}

C_EXPORT int QPictureIO_status(QPictureIOH handle)
{
	return (int) ((QPictureIO *)handle)->status();
}

C_EXPORT const char* QPictureIO_format(QPictureIOH handle)
{
	return (const char*) ((QPictureIO *)handle)->format();
}

C_EXPORT QIODeviceH QPictureIO_ioDevice(QPictureIOH handle)
{
	return (QIODeviceH) ((QPictureIO *)handle)->ioDevice();
}

C_EXPORT void QPictureIO_fileName(QPictureIOH handle, PWideString retval)
{
	QString t_retval;
	t_retval = ((QPictureIO *)handle)->fileName();
	copyQStringToPWideString(t_retval, retval);
}

C_EXPORT int QPictureIO_quality(QPictureIOH handle)
{
	return (int) ((QPictureIO *)handle)->quality();
}

C_EXPORT void QPictureIO_description(QPictureIOH handle, PWideString retval)
{
	QString t_retval;
	t_retval = ((QPictureIO *)handle)->description();
	copyQStringToPWideString(t_retval, retval);
}

C_EXPORT const char* QPictureIO_parameters(QPictureIOH handle)
{
	return (const char*) ((QPictureIO *)handle)->parameters();
}

C_EXPORT float QPictureIO_gamma(QPictureIOH handle)
{
	return (float) ((QPictureIO *)handle)->gamma();
}

C_EXPORT void QPictureIO_setPicture(QPictureIOH handle, const QPictureH p1)
{
	((QPictureIO *)handle)->setPicture(*(const QPicture*)p1);
}

C_EXPORT void QPictureIO_setStatus(QPictureIOH handle, int p1)
{
	((QPictureIO *)handle)->setStatus(p1);
}

C_EXPORT void QPictureIO_setFormat(QPictureIOH handle, const char* p1)
{
	((QPictureIO *)handle)->setFormat(p1);
}

C_EXPORT void QPictureIO_setIODevice(QPictureIOH handle, QIODeviceH p1)
{
	((QPictureIO *)handle)->setIODevice((QIODevice*)p1);
}

C_EXPORT void QPictureIO_setFileName(QPictureIOH handle, PWideString p1)
{
	QString t_p1;
	copyPWideStringToQString(p1, t_p1);
	((QPictureIO *)handle)->setFileName(t_p1);
}

C_EXPORT void QPictureIO_setQuality(QPictureIOH handle, int p1)
{
	((QPictureIO *)handle)->setQuality(p1);
}

C_EXPORT void QPictureIO_setDescription(QPictureIOH handle, PWideString p1)
{
	QString t_p1;
	copyPWideStringToQString(p1, t_p1);
	((QPictureIO *)handle)->setDescription(t_p1);
}

C_EXPORT void QPictureIO_setParameters(QPictureIOH handle, const char* p1)
{
	((QPictureIO *)handle)->setParameters(p1);
}

C_EXPORT void QPictureIO_setGamma(QPictureIOH handle, float p1)
{
	((QPictureIO *)handle)->setGamma(p1);
}

C_EXPORT bool QPictureIO_read(QPictureIOH handle)
{
	return (bool) ((QPictureIO *)handle)->read();
}

C_EXPORT bool QPictureIO_write(QPictureIOH handle)
{
	return (bool) ((QPictureIO *)handle)->write();
}

C_EXPORT void QPictureIO_pictureFormat(QByteArrayH retval, PWideString fileName)
{
	QString t_fileName;
	copyPWideStringToQString(fileName, t_fileName);
	*(QByteArray *)retval = QPictureIO::pictureFormat(t_fileName);
}

C_EXPORT void QPictureIO_pictureFormat2(QByteArrayH retval, QIODeviceH p1)
{
	*(QByteArray *)retval = QPictureIO::pictureFormat((QIODevice*)p1);
}

C_EXPORT void QPictureIO_defineIOHandler(const char* format, const char* header, const char* flags, picture_io_handler read_picture, picture_io_handler write_picture)
{
	QPictureIO::defineIOHandler(format, header, flags, read_picture, write_picture);
}

