//******************************************************************************
//  Copyright (c) 2005-2009 by Jan Van hijfte
//
//  See the included file COPYING.TXT for details about the copyright.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//******************************************************************************


C_EXPORT QWorkspaceH QWorkspace_create(QWidgetH parent)
{
	return (QWorkspaceH) new QWorkspace((QWidget*)parent);
}

C_EXPORT void QWorkspace_destroy(QWorkspaceH handle)
{
	delete (QWorkspace *)handle;
}

C_EXPORT QWidgetH QWorkspace_activeWindow(QWorkspaceH handle)
{
	return (QWidgetH) ((QWorkspace *)handle)->activeWindow();
}

C_EXPORT void QWorkspace_windowList(QWorkspaceH handle, PPtrIntArray retval, QWorkspace::WindowOrder order)
{
	QList<QWidget*> t_retval;
	t_retval = ((QWorkspace *)handle)->windowList(order);
	copyQListTemplateToPtrIntArray(t_retval, retval);
}

C_EXPORT QWidgetH QWorkspace_addWindow(QWorkspaceH handle, QWidgetH w, unsigned int flags)
{
	return (QWidgetH) ((QWorkspace *)handle)->addWindow((QWidget*)w, (Qt::WindowFlags)flags);
}

C_EXPORT void QWorkspace_sizeHint(QWorkspaceH handle, PSize retval)
{
	*(QSize *)retval = ((QWorkspace *)handle)->sizeHint();
}

C_EXPORT bool QWorkspace_scrollBarsEnabled(QWorkspaceH handle)
{
	return (bool) ((QWorkspace *)handle)->scrollBarsEnabled();
}

C_EXPORT void QWorkspace_setScrollBarsEnabled(QWorkspaceH handle, bool enable)
{
	((QWorkspace *)handle)->setScrollBarsEnabled(enable);
}

C_EXPORT void QWorkspace_setBackground(QWorkspaceH handle, const QBrushH background)
{
	((QWorkspace *)handle)->setBackground(*(const QBrush*)background);
}

C_EXPORT void QWorkspace_background(QWorkspaceH handle, QBrushH retval)
{
	*(QBrush *)retval = ((QWorkspace *)handle)->background();
}

C_EXPORT void QWorkspace_setActiveWindow(QWorkspaceH handle, QWidgetH w)
{
	((QWorkspace *)handle)->setActiveWindow((QWidget*)w);
}

C_EXPORT void QWorkspace_cascade(QWorkspaceH handle)
{
	((QWorkspace *)handle)->cascade();
}

C_EXPORT void QWorkspace_tile(QWorkspaceH handle)
{
	((QWorkspace *)handle)->tile();
}

C_EXPORT void QWorkspace_arrangeIcons(QWorkspaceH handle)
{
	((QWorkspace *)handle)->arrangeIcons();
}

C_EXPORT void QWorkspace_closeActiveWindow(QWorkspaceH handle)
{
	((QWorkspace *)handle)->closeActiveWindow();
}

C_EXPORT void QWorkspace_closeAllWindows(QWorkspaceH handle)
{
	((QWorkspace *)handle)->closeAllWindows();
}

C_EXPORT void QWorkspace_activateNextWindow(QWorkspaceH handle)
{
	((QWorkspace *)handle)->activateNextWindow();
}

C_EXPORT void QWorkspace_activatePreviousWindow(QWorkspaceH handle)
{
	((QWorkspace *)handle)->activatePreviousWindow();
}

